//
//  AppDelegate.m
//  Demo
//
//  Created by edz on 2020/12/21.
//  Copyright © 2020 ryw. All rights reserved.
//

#import "AppDelegate.h"
#import <KSCLoginSDK/KSCLoginSDK.h>
#import "KSCSDKUntils.h"
#import <CoreTelephony/CTCellularData.h>
#import "FirstLaunchManager.h"

#define FIRSTINSTALLKEY @"HasInstall"

@interface AppDelegate ()

@end

@implementation AppDelegate

- (void)initSDKWithFirstInstall{
    NSUserDefaults *userDefaults = [NSUserDefaults standardUserDefaults];
    //首次安装需要检测是不是首次安装  如果沙盒有东西 说明不是首次
    if(![userDefaults boolForKey:@"firstLaunch"]) {
        [userDefaults setBool:YES forKey:@"firstLaunch"];
        NSLog(@"安装之后首次开启App");
        //这里是没有网络的
        
        /***
        在这里调用初始化接口,完成接口初始化记得要 调用[FirstLaunchManager finishLaunch]
        因为是监听网络变化,当网络可用的时候会进行一次调用.多次初始化对APP不好.
        如果有特殊需求可以调用[FirstLaunchManager restLaunch]重置初始化,app每次进入会重置一次.
        */
#if TARGET_IPHONE_SIMULATOR//第三方库FirstLaunchManager 不支持模拟器，否则编译出错
        [self initSDK];
#elif TARGET_OS_IPHONE//真机
        [[FirstLaunchManager Handler] LaunchApplicationBlock:^{
            NSLog(@"初始化");
            [self initSDK];
            BOOL finishLaunch = YES;
            if (finishLaunch) {
                [FirstLaunchManager finishLaunch];
            }
        }];
#endif
    } else {
        [self initSDK];
    }
}


- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions {
    [self initSDKWithFirstInstall];
    return YES;
}

- (void)initSDK {
    //在APP启动完的时候 注册SDK
    [KSCSDKLogin ksc_registerWithAppID:appId completion:^(BOOL isRegist) {
        NSLog(@"注册成功%d", isRegist);
    }];
    // 控制台日志输出控制（默认关闭） 方便调试，上线的时候可以关闭
    [KSCSDKLogin ksc_printConsoleEnable:YES];
}

//在AppDelegate中添加以下代码
// 监听网络状态
- (void)observeNetWork {
//    [[AFNetworkReachabilityManager sharedManager] startMonitoring];
//    [[AFNetworkReachabilityManager sharedManager] setReachabilityStatusChangeBlock:^(AFNetworkReachabilityStatus status) {
//        if (status == AFNetworkReachabilityStatusNotReachable || status == AFNetworkReachabilityStatusUnknown) {
//            //无网络链接
//        } else {
//            //网络链接成功，上传IDFA
//            [self uploadIDFA];
//        }
//    }];
}

@end
