//
//  ResultViewController.m
//  Demo
//
//  Created by edz on 2020/12/25.
//  Copyright © 2020 ryw. All rights reserved.
//

#import "ResultViewController.h"
#import "Common.h"
#import "KSCSDKUntils.h"
#import "FLAnimatedImage.h"
#import "KSCProgressHUD.h"

@interface ResultViewController ()
@property (weak, nonatomic) IBOutlet FLAnimatedImageView *resultImageView;

@property (weak, nonatomic) IBOutlet UILabel *resultLabel;
@property (weak, nonatomic) IBOutlet UILabel *mobileLabel;
@property (weak, nonatomic) IBOutlet UIButton *returnHomeBtn;

@end

@implementation ResultViewController

- (NSMutableDictionary *)data{
    if (_data == nil ) {
        _data = [[NSMutableDictionary alloc]init];
    }
    return _data;
}

- (void)backAction {
    [self.navigationController popViewControllerAnimated:YES];
}

- (void)viewDidLoad {
    [super viewDidLoad];
    self.returnHomeBtn.enabled = NO;
//    self.navigationController.navigationBar.hidden = NO;
    
    if (self.isOneLogin) {
        [self.data setObject:@"999" forKey:@"AuthStatus"];
        [self.data setObject:@"登录中..." forKey:@"ErrMsg"];
        NSString *token = self.data[@"token"];
        [self validateToken:token mobileStr:nil];
        NSLog(@"==++++===%@", self.data);
        /*
         {
         operatortype = "\U4e2d\U56fd\U8054\U901a";
         result = "\U83b7\U53d6token\U6210\U529f";
         resultCode = 103000;
         securityPhone = "132****1286";
         token = STsid0000001608885703797kt2wrICl3BvMYSwwm583mO7RoyRfmjSn;
         traceId = 9ad68d0b80bd3b0f9c9f6b7da66bddfd;
         }
         */
    } else {
        [self.data setObject:@"1000" forKey:@"AuthStatus"];
        [self.data setObject:@"认证中..." forKey:@"ErrMsg"];
        NSString *mobile = self.data[@"mobile"];
        NSString *token = self.data[@"token"];
        [self validateToken:token mobileStr:mobile];
        /*
         {
         operatortype = "\U4e2d\U56fd\U8054\U901a";
         resultCode = 103000;
         securityPhone = "132****1286";
         token = STsid0000001608885817248X5wv1d0q7BypkUw04UBGZh1C1Lu3XSuV;
         traceId = 8e6f60c9ac547f50c5e304b06786a706;
         }
         */
    }
    [self updateUI];
    
    if (![UIDevice currentDevice].generatesDeviceOrientationNotifications) {
        [[UIDevice currentDevice] beginGeneratingDeviceOrientationNotifications];
    }
}

- (void)updateUI {
    /*
     data =     {
     AuthStatus = 2;
     Code = 200;
     ErrMsg = "\U8bf7\U6c42\U6210\U529f";
     };
     data =     {
     AuthStatus = 2;
     Code = 1105;
     ErrMsg = "\U6e90IP\U4e0d\U5728\U62a5\U5907\U767d\U540d\U5355\U4e2d";
     Mobile = "";
     };
     */
    self.mobileLabel.hidden = YES;
    switch ([[self.data objectForKey:@"AuthStatus"] intValue]) {
        case 1:
        {
            NSString *path = [[NSBundle mainBundle] pathForResource:@"登录成功" ofType:@"gif"];
            NSData *data = [NSData dataWithContentsOfFile:path];
            FLAnimatedImage *image = [FLAnimatedImage animatedImageWithGIFData:data];
            self.resultImageView.animatedImage = image;
            self.mobileLabel.hidden = NO;
            NSString *mobileStr = [self.data objectForKey:@"Mobile"];
            if (mobileStr) {
                self.mobileLabel.text = mobileStr;
            }
            if(self.isOneLogin){
                self.resultLabel.text = @"登录成功";
            }else{
                self.resultLabel.text = @"认证成功";
            }
            [self.resultImageView stopAnimating];
            UIImage *imagez = image.testImage;
            self.resultImageView.image = imagez;
        }
            break;
        case 2:
        {
            NSString *path = [[NSBundle mainBundle] pathForResource:@"登录失败" ofType:@"gif"];
            NSData *data = [NSData dataWithContentsOfFile:path];
            FLAnimatedImage *image = [FLAnimatedImage animatedImageWithGIFData:data];
            self.resultImageView.animatedImage = image;
            self.resultLabel.textColor = RGBA(195, 195, 195, 1);
            if(self.isOneLogin){
                self.resultLabel.text = @"登录失败";
            } else {
                self.resultLabel.text = @"认证失败";
            }
            NSString *errmsgStr = [self.data objectForKey:@"errmsg"];
            if (errmsgStr) {
                self.mobileLabel.text = errmsgStr;
                self.mobileLabel.hidden = NO;
            }
            [self.resultImageView stopAnimating];
        }
            break;
        case 999:
        {
            NSString *path = [[NSBundle mainBundle] pathForResource:@"登录中动态图" ofType:@"gif"];
            NSData *data = [NSData dataWithContentsOfFile:path];
            FLAnimatedImage *image = [FLAnimatedImage animatedImageWithGIFData:data];
            self.resultImageView.animatedImage = image;
            self.resultLabel.text = @"登录中...";
        }
            break;
        case 1000:
        {
            NSString *path = [[NSBundle mainBundle] pathForResource:@"预取号动态" ofType:@"gif"];
            NSData *data = [NSData dataWithContentsOfFile:path];
            FLAnimatedImage *image = [FLAnimatedImage animatedImageWithGIFData:data];
            self.resultImageView.animatedImage = image;
            self.resultLabel.text = @"认证中...";
        }
            break;
        default:
            break;
    }
}

/**
 ！！！！和自己公司服务器对接 发送请求
 ========================================================================
 oneLogin发送请求 携带参数  一共是3个 app_id 、 token 、sign（sign是根据前2个参数算出来的签名，具体算法参照方法中的实现）
 
 ========================================================================
 onePass发送请求 携带参数  一共是4个 app_id 、mobile 、 token 、sign（sign是根据前3个参数算出来的签名，具体算法参照方法中的实现）
 */
- (void)validateToken:(NSString *)token mobileStr:(NSString *)phoneNumStr
{
    //线上环境
    NSURL *url;
    if (self.isOneLogin) {
        url = [NSURL URLWithString:[NSString stringWithFormat:@"%@", KSCOneLoginResultURL]];
    }else{
        url = [NSURL URLWithString:[NSString stringWithFormat:@"%@", KSCOnePassVerifyURL]];
    }
    
    //配置参数字典作为请求体
    NSMutableDictionary *dic = [NSMutableDictionary dictionary];
    dic[KSC_PARMS_APPID_KEY] = appId;
    
    NSString *tokenStr = token;
    dic[KSC_PARMS_TOKEN_KEY] = tokenStr;
    
    NSString *hmacStr = nil;
    if (self.isOneLogin) {
        hmacStr = [NSString stringWithFormat:@"app_id%@token%@", appId,tokenStr];
    } else {
        //这里需要用户输入的号码
        NSString *mobileStr = phoneNumStr;
        dic[KSC_PARMS_IPHONE_KEY] = mobileStr;
        
        hmacStr = [NSString stringWithFormat:@"app_id%@mobile%@token%@", appId, mobileStr, tokenStr];
    }
    NSString *signStr = [KSCSDKUntils hmac:hmacStr withKey:HMAC_SHA256_KEY];
    dic[KSC_PARMS_SIGIN_KEY] = signStr;
    //配置request
    NSMutableURLRequest *request = [NSMutableURLRequest requestWithURL:url cachePolicy:NSURLRequestUseProtocolCachePolicy timeoutInterval:5.0];
    request.HTTPBody = [NSJSONSerialization dataWithJSONObject:dic options:NSJSONWritingPrettyPrinted error:nil];
    request.HTTPMethod = @"POST";
    [request addValue:@"application/json" forHTTPHeaderField:@"Content-Type"];
    
    NSLog(@"=+++++++++====%@",dic);
    //超时处理 没法测试
    NSURLSession *sharedSession = NSURLSession.sharedSession;
   
    [[sharedSession dataTaskWithRequest:request completionHandler:^(NSData * _Nullable data, NSURLResponse * _Nullable response, NSError * _Nullable error) {
        [NSOperationQueue.mainQueue addOperationWithBlock:^{
//            [KSCProgressHUD hideAllHUD];
            self.returnHomeBtn.enabled = YES;
            if (data.length > 0) {
                NSString *dataString = [[NSString alloc] initWithData:data encoding:NSUTF8StringEncoding];
                NSMutableDictionary *dataDict = [KSCSDKUntils covertToDic:dataString].mutableCopy;
                [self finaly:dataDict];
            }
            
            if (error != nil) { //超时
                NSMutableDictionary *dic = [NSMutableDictionary dictionaryWithDictionary:@{@"errno":@"621004", @"errmsg": @"超时请返回首页重试"}];
                
                [self finaly:dic];
            }
        }];
    }] resume];
    
}


/*
错误号    msg
621004
每天发送限制10条
621005
发送过于频繁，稍后再试
例如：

{
"errno": 621005,
"errmsg": "发送过于频繁，稍后再试",
"data": [],
"request_id": "8edf0f59-29a8-4c90-9fce-886d3bcd0534"
}
*/
- (void)finaly:(NSDictionary *)result {
    NSInteger code = [[result objectForKey:@"errno"] integerValue];
    id data = [result objectForKey:@"data"];
    id errmsg = [result objectForKey:@"errmsg"];
    //状态码正确   而且data键值是个字典
    if (code == 10000 && result && data && [data isKindOfClass:[NSDictionary class]]) {
        self.data =  [NSMutableDictionary dictionaryWithDictionary:data];
    } else {
        self.data = [NSMutableDictionary dictionaryWithDictionary:@{
            @"AuthStatus": @2,
        }];
        if (errmsg && [errmsg isKindOfClass:[NSString class]]) {
            if (code == 621004 || code == 621005) { //只在这两种情况下显示错误原因
                [self.data setObject:errmsg forKey:@"errmsg"];
            }
        }
    }
    [self updateUI];
}

- (IBAction)popToRootVCBtnClick {
    [self.navigationController popToRootViewControllerAnimated:YES];
}

- (IBAction)backBtnClick {
    [self.navigationController popViewControllerAnimated:YES];
}
@end
