//
//  KSCUntils.h
//  KSCLoginSDK
//
//  Created by cqc on 2020/5/7.
//  Copyright © 2020 cqc. All rights reserved.
//

#import <Foundation/Foundation.h>
//#import "KOPError.h"

#define dispatch_main_async_safe(block)             \
if ([NSThread isMainThread]) {                      \
block();                                            \
} else {                                            \
dispatch_async(dispatch_get_main_queue(), block);   \
}

#define     TLWeakSelf(type)            __weak typeof(type) weak##type = type;

//颜色
#define ssRGBHex(rgbValue) [UIColor colorWithRed:((float)((rgbValue & 0xFF0000) >> 16))/255.0 green:((float)((rgbValue & 0xFF00) >> 8))/255.0 blue:((float)(rgbValue & 0xFF))/255.0 alpha:1.0]
#define ssRGBHexAlpha(rgbValue,a) [UIColor colorWithRed:((float)((rgbValue & 0xFF0000) >> 16))/255.0 green:((float)((rgbValue & 0xFF00) >> 8))/255.0 blue:((float)(rgbValue & 0xFF))/255.0 alpha:(a)]

#define sdkversion   @"1.0.0"
#define HMAC_SHA256_KEY   @"4036e96ebd064bm3b1fde9g30b03s4d4"
#define SALT_KEY          @"31067aa1fb9ff7a"

//测试环境
//#define KSCOneLoginResultURL @"http://testconsole.ksyun.com/i/console/onepass/demo/mobile/query"
//#define KSCOnePassVerifyURL  @"http://testconsole.ksyun.com/i/console/onepass/demo/mobile/validate"
//线上环境
#define KSCOneLoginResultURL @"https://console.ksyun.com/i/console/onepass/demo/mobile/query"
#define KSCOnePassVerifyURL  @"https://console.ksyun.com/i/console/onepass/demo/mobile/validate"

#define KSC_PARMS_SIGIN_KEY @"sign"
#define KSC_PARMS_TOKEN_KEY @"token"
#define KSC_PARMS_APPID_KEY @"app_id"
#define KSC_PARMS_IPHONE_KEY @"mobile"


#define SUCCESSCODE @"103000"

//该appId 是从金山云后台注册而来
#define appId  @"9M3n4sMgRuWyaznJv9a3LA"

//从中移申请的账号对应的金山云appid
//#define appId  @"DFNItefuSA-gFcFaAGaKyA"




//#define appId  @"nAZzW6z0SoCBGaldNUNDQw"



#define GPRS_TIP  @"未检测到网络"
#define GPRS_AUTHORIZATION_TIP @"请开启移动网络"

NS_ASSUME_NONNULL_BEGIN

@interface KSCSDKUntils : NSObject
//+ (NSDictionary *)makeErrorDict:(KOPErrorCode )ecode  msg:(NSString *)msg;
+ (NSString *)hmac:(NSString *)plaintext withKey:(NSString *)key;
+ (NSDictionary *)covertToDic:(NSString *)str;

/**返回提示信息
 当有WiFi没有蜂窝 返回 @"请开启移动网络"
 没有WiFi没有蜂窝 返回 @"未检测到网络"
 其他情况返回 @""
 */
+ (NSString *)getNoNetworkToastStr;

@end

NS_ASSUME_NONNULL_END
