//
//  KSCUntils.m
//  KSCLoginSDK
//
//  Created by cqc on 2020/5/7.
//  Copyright © 2020 cqc. All rights reserved.
//

#import "KSCSDKUntils.h"
#import <CommonCrypto/CommonDigest.h>
#import <CommonCrypto/CommonHMAC.h>
#import <KSCLoginSDK/KSCLoginSDK.h>

@implementation KSCSDKUntils
+ (NSString *)hmac:(NSString *)plaintext withKey:(NSString *)key
{
    const char *cKey  = [key cStringUsingEncoding:NSASCIIStringEncoding];
    const char *cData = [plaintext cStringUsingEncoding:NSASCIIStringEncoding];
    unsigned char cHMAC[CC_SHA256_DIGEST_LENGTH];
    CCHmac(kCCHmacAlgSHA256, cKey, strlen(cKey), cData, strlen(cData), cHMAC);
    NSData *HMACData = [NSData dataWithBytes:cHMAC length:sizeof(cHMAC)];
    const unsigned char *buffer = (const unsigned char *)[HMACData bytes];
    NSMutableString *HMAC = [NSMutableString stringWithCapacity:HMACData.length * 2];
    for (int i = 0; i < HMACData.length; ++i){
        [HMAC appendFormat:@"%02x", buffer[i]];
    }
    return HMAC;
}

+ (NSDictionary *)covertToDic:(NSString *)str {
    if (![str isKindOfClass:[NSString class]]||str.length == 0) {
        return [NSDictionary dictionary];
    }
    
    NSError *error;
    NSData *data = [str dataUsingEncoding:NSUTF8StringEncoding];
    NSDictionary *dic = [NSJSONSerialization JSONObjectWithData:data options:0 error:&error];
    if (error) {
        return [NSDictionary dictionary];
    }
    return dic;
}

+ (NSString *)getNoNetworkToastStr {
    /**
     网络类型及运营商（双卡下，获取上网卡的运营商）
     "carrier"     运营商： 0.未知 / 1.中国移动 / 2.中国联通 / 3.中国电信
     "networkType" 网络类型： 0.无网络/ 1.数据流量 / 2.wifi / 3.数据+wifi
     @return  @{NSString : NSNumber}
     */
    NSDictionary *dic = [KSCSDKLogin networkInfo];
    NSNumber *num = dic[@"networkType"];
    if (num.intValue == 0) {
        return GPRS_TIP;
    } else if (num.intValue == 2) {
        return GPRS_AUTHORIZATION_TIP;
    } else {
        return @"";
    }
}

@end
