//
//  KSCSDKErrorCode.h
//  KSCLoginSDK
//
//  Created by edz on 2020/12/22.
//  Copyright © 2020 ryw. All rights reserved.
//

#ifndef KSCSDKErrorCode_h
#define KSCSDKErrorCode_h

#import <Foundation/Foundation.h>

typedef NSString *KSCSDKErrorCode;

//成功
static KSCSDKErrorCode const KSCSDKErrorCodeSuccess                = @"103000";
//数据解析异常
static KSCSDKErrorCode const KSCSDKErrorCodeProcessException       = @"200021";
//无网络
static KSCSDKErrorCode const KSCSDKErrorCodeNoNetwork              = @"200022";
//请求超时
static KSCSDKErrorCode const KSCSDKErrorCodeRequestTimeout         = @"200023";
//未知错误
static KSCSDKErrorCode const KSCSDKErrorCodeUnknownError           = @"200025";
//蜂窝未开启或不稳定
static KSCSDKErrorCode const KSCSDKErrorCodeNonCellularNetwork     = @"200027";
//网络请求出错(HTTP Code 非200)
static KSCSDKErrorCode const KSCSDKErrorCodeRequestError           = @"200028";
//非移动网关重定向失败
static KSCSDKErrorCode const KSCSDKErrorCodeWAPRedirectFailed      = @"200038";
//无SIM卡
static KSCSDKErrorCode const KSCSDKErrorCodePhoneWithoutSIM        = @"200048";
//Socket创建或发送接收数据失败
static KSCSDKErrorCode const KSCSDKErrorCodeSocketError            = @"200050";
//用户点击了“账号切换”按钮（自定义短信页面customSMS为YES才会返回）
static KSCSDKErrorCode const KSCSDKErrorCodeCustomSMSVC            = @"200060";
//显示登录"授权页面"被拦截（hooked）
static KSCSDKErrorCode const KSCSDKErrorCodeAutoVCisHooked         = @"200061";
////预取号不支持联通
//static KSCSDKErrorCode const KSCSDKErrorCodeNOSupportUnicom        = @"200062";
////预取号不支持电信
//static KSCSDKErrorCode const KSCSDKErrorCodeNOSupportTelecom       = @"200063";
//服务端返回数据异常
static KSCSDKErrorCode const KSCSDKErrorCodeExceptionData          = @"200064";
//CA根证书校验失败
static KSCSDKErrorCode const KSCSDKErrorCodeCAAuthFailed           = @"200072";
//本机号码校验仅支持移动手机号
static KSCSDKErrorCode const KSCSDKErrorCodeGetMoblieOnlyCMCC      = @"200080";
//服务器繁忙
static KSCSDKErrorCode const KSCSDKErrorCodeServerBusy             = @"200082";
//ppLocation为空
static KSCSDKErrorCode const KSCSDKErrorCodeLocationError          = @"200086";
//监听授权界面成功弹起
static KSCSDKErrorCode const KSCSDKSuccessGetAuthVCCode            = @"200087";
//当前网络不支持取号
static KSCSDKErrorCode const KSCSDKErrorCodeUnsupportedNetwork     = @"200096";

/**
 获取错误码描述

 @param code 错误码
 @return 返回对应描述
 */
FOUNDATION_EXPORT NSString *KSCSDKErrorDescription(KSCSDKErrorCode code);

#endif /* KSCSDKErrorCode_h */
